;   

BAIT1		EQU	20H	;  
BAIT2		EQU	21H	;     

RAZ1		EQU	30H
RAZ2	 	EQU	31H
RAZ3	 	EQU	32H
RAZ4	 	EQU	33H
RAZ5	        EQU	34H
RAZ6		EQU	35H
RAZ7	 	EQU	36H
RAZ8	 	EQU	37H

ZADKN		EQU	5CH	;   
	  
ZN1PW           BIT     20H.0	;  
ZN2PW           BIT     20H.1
ZN3PW		BIT	20H.2
ZN4PW           BIT     20H.3
ZN5PW           BIT     20H.4
ZN6PW		BIT	20H.5
ZN7PW		BIT	20H.6
ZN8PW		BIT	20H.7

AL1             BIT     21H.0	;
AL2             BIT     21H.1
AL3  		BIT	21H.2
AL4             BIT     21H.3
AL5             BIT     21H.4
AL6  		BIT	21H.5
AL7		BIT	21H.6
AL8		BIT	21H.7


PUSK            BIT     2AH.0 ;
PUSK1           BIT     2AH.1 ;
KLAV            BIT     2AH.2
FLAG            BIT     2AH.3
FLAG1           BIT     2AH.4
FLAG2           BIT     2AH.5
FLAG3	        BIT     2AH.6
FLAG4	        BIT     2AH.7

REV	  	BIT	2BH.0 ;
REV1	  	BIT	2BH.1 ;
COMB            BIT     2BH.2 ;   
WKLW            BIT     2BH.3 ;   


        JMP     INIT

        ORG     0BH
        JMP     OT
                                                
INIT:   CLR      A
	MOV	 R0,#RAZ1	;   	
	MOV	 R2,#0		;
        MOV      R3,#10        ; 0,1 
        MOV	 R4,#0		;  
	MOV	 R6,#1		;   
	MOV	 R7,#1 		; 

	
        MOV      TMOD,#00000001B   
        MOV      TL0,#LOW(-3400)
        MOV      TH0,#HIGH(-3400)
 
	MOV	 RAZ1,#0FFH	
	MOV	 RAZ2,#0FFH
	MOV	 RAZ3,#0FFH
	MOV	 RAZ4,#0FFH
	MOV	 RAZ5,#0FFH	
	MOV	 RAZ6,#0FFH	
	MOV	 RAZ7,#0FFH	
	MOV	 RAZ8,#0FFH
	
	MOV	 BAIT1,#11111111B  
	MOV	 BAIT2,#11111111B 
	MOV	 P3,#11111111B                
        CLR      FLAG             
        CLR      FLAG1            
        CLR      FLAG2
	CLR	 FLAG3
   	CLR	 FLAG4
	CLR	 PUSK
	CLR	 PUSK1
	CLR	 COMB
	CLR	 REV
	CLR      WKLW
	SETB	 REV1	
	SETB	 C
	
INTR1:				;  DD1
	MOV	P1,BAIT1
	CLR	P3.1
	NOP
	SETB	P3.1
	
SEC1:	SETB     TR0              
        SETB     ET0  
        SETB     EA 

SE1:    JNB     PUSK1,SE1    ;     
	JNB     PUSK,SE1     ;      
        CLR     PUSK 

	JNB     COMB,WE1  
	JNB     AL1,PER13
	JMP     WE2

WE1:	MOV     A,P3
	RR      A
	RR	A
	ANL     A,#00001111B
	CJNE    A,#00000001B,EFS2

;    1  
 
PER13:	INC      R4
	CJNE     R4,#72,ZKR11
	JNB      REV,ZLOK1  
	CPL      REV1
	INC      R2
	CJNE     R2,#3,ZLOK1
	MOV      R2,#0
	SETB     AL1
ZLOK1:	MOV	 R4,#0
	MOV	 RAZ8,#11111111B
	MOV	 RAZ1,#11111111B



ZKR11:	JNB      REV,PER11     ;     
        JNB      REV1,PEZ11 

PER11:	CJNE     R4,#1,PER1
	CLR      C
	MOV      R1,#RAZ1
	JMP      TEK2
EFS2:   JMP      EF2
PER1:	CJNE     R4,#9,PER2
	CLR      C
	MOV	 RAZ1,#11111111B
	MOV      R1,#RAZ2
	JMP      TEK2
PER2:	CJNE     R4,#18,PER3
	CLR      C
	MOV	 RAZ2,#11111111B
	MOV      R1,#RAZ3
	JMP      TEK2
PER3:	CJNE     R4,#27,PER4
	CLR      C
	MOV	 RAZ3,#11111111B
	MOV      R1,#RAZ4
	JMP      TEK2
PER4:	CJNE     R4,#36,PER5
	CLR      C
	MOV	 RAZ4,#11111111B
	MOV      R1,#RAZ5
	JMP      TEK2
PER5:	CJNE     R4,#45,PER6
	CLR      C
	MOV	 RAZ5,#11111111B
	MOV      R1,#RAZ6
	JMP      TEK2
PER6:	CJNE     R4,#54,PER7
	CLR      C
	MOV	 RAZ6,#11111111B
	MOV      R1,#RAZ7
	JMP      TEK2
PER7:	CJNE     R4,#63,TEKS2
	CLR      C
	MOV	 RAZ7,#11111111B
	MOV      R1,#RAZ8
TEKS2:	JMP      TEK2
;EFS3:   JMP      EF3

	;

PEZ11:	CJNE     R4,#1,PEZ1
	CLR      C
	MOV      R1,#RAZ8
	JMP      ZEX21
;EFS2:   JMP      EF2
PEZ1:	CJNE     R4,#9,PEZ2
	CLR      C
	MOV	 RAZ8,#11111111B
	MOV      R1,#RAZ7
	JMP      ZEX21
PEZ2:	CJNE     R4,#18,PEZ3
	CLR      C
	MOV	 RAZ7,#11111111B
	MOV      R1,#RAZ6
	JMP      ZEX21
PEZ3:	CJNE     R4,#27,PEZ4
	CLR      C
	MOV	 RAZ6,#11111111B
	MOV      R1,#RAZ5
	JMP      ZEX21
PEZ4:	CJNE     R4,#36,PEZ5
	CLR      C
	MOV	 RAZ5,#11111111B
	MOV      R1,#RAZ4
	JMP      ZEX21
PEZ5:	CJNE     R4,#45,PEZ6
	CLR      C
	MOV	 RAZ4,#11111111B
	MOV      R1,#RAZ3
	JMP      ZEX21
PEZ6:	CJNE     R4,#54,PEZ7
	CLR      C
	MOV	 RAZ3,#11111111B
	MOV      R1,#RAZ2
	JMP      ZEX21
PEZ7:	CJNE     R4,#63,PEZ8
	CLR      C
	MOV	 RAZ2,#11111111B
	MOV	 RAZ1,#01111111B
	JMP      SE1

PEZ8:	CJNE     R4,#64,PEZ9	
	MOV	 RAZ1,#10111111B
	JMP      SE1

PEZ9:	CJNE     R4,#65,PEZ10	
	MOV	 RAZ1,#11011111B
	JMP      SE1

PEZ10:	CJNE     R4,#66,PEZ111	
	MOV	 RAZ1,#11101111B
	JMP      SE1

PEZ111:	CJNE     R4,#67,PEZ12	
	MOV	 RAZ1,#11110111B
	JMP      SE1

PEZ12:	CJNE     R4,#68,PEZ13	
	MOV	 RAZ1,#11111011B
	JMP      SE1

PEZ13:	CJNE     R4,#69,PEZ14	
	MOV	 RAZ1,#11111101B
	JMP      SE1

PEZ14:	CJNE     R4,#70,PEZ15	
	MOV	 RAZ1,#11111110B
	JMP      SE1

PEZ15:	CJNE     R4,#71,ZEX21	
	MOV	 RAZ1,#11111111B
	JMP      SE1
		
ZEX21:	MOV	 A,@R1
	RRC	 A
	MOV	 @R1,A
	JMP	 SE1

EFS3:   JMP      EF3

;    2  

WE2:	JNB     AL2,WE21
	JMP     WE3

EF2:    CJNE    A,#00000010B,EFS3

WE21:	INC      R4
	CJNE     R4,#64,MER11
	MOV	 R4,#0
	MOV	 RAZ8,#11111111B
	SETB     AL2

MER11:	CJNE     R4,#1,MER1
	CLR      C
	MOV      R1,#RAZ1
	JMP      TEK2
MER1:	CJNE     R4,#2,MER101
	CLR      C
	JMP      TEK2

MER101:	CJNE     R4,#9,MER201
	CLR      C
	MOV	 RAZ1,#01111111B
	MOV      R1,#RAZ2
	JMP      TEK2
MER201:	CJNE     R4,#10,MER2
	CLR      C
	MOV	 RAZ1,#11111111B
	JMP      TEK2

MER2:	CJNE     R4,#18,MER301
	CLR      C
	MOV	 RAZ2,#01111111B
	MOV      R1,#RAZ3
	JMP      TEK2
MER301:	CJNE     R4,#19,MER3
	CLR      C
	MOV	 RAZ2,#11111111B
	JMP      TEK2

MER3:	CJNE     R4,#27,MER401
	CLR      C
	MOV	 RAZ3,#01111111B
	MOV      R1,#RAZ4
	JMP      TEK2
MER401:	CJNE     R4,#28,MER4
	CLR      C
	MOV	 RAZ3,#11111111B
	JMP      TEK2

MER4:	CJNE     R4,#36,MER501
	CLR      C
	MOV	 RAZ4,#01111111B
	MOV      R1,#RAZ5
	JMP      TEK2
MER501:	CJNE     R4,#37,MER5
	CLR      C
	MOV	 RAZ4,#11111111B
	JMP      TEK2

MER5:	CJNE     R4,#45,MER601
	CLR      C
	MOV	 RAZ5,#01111111B
	MOV      R1,#RAZ6
	JMP      TEK2
MER601:	CJNE     R4,#46,MER6
	CLR      C
	MOV	 RAZ5,#11111111B
	JMP      TEK2

MER6:	CJNE     R4,#54,MER701
	CLR      C
	MOV	 RAZ6,#01111111B
	MOV      R1,#RAZ7
	JMP      TEK2
MER701:	CJNE     R4,#55,MER7
	CLR      C
	MOV	 RAZ6,#11111111B
	JMP      TEK2

MER7:	CJNE     R4,#63,MER801
	CLR      C
	MOV	 RAZ7,#01111111B
	MOV      R1,#RAZ8
MER801:	CJNE     R4,#64,MEKS2
	CLR      C
	MOV	 RAZ7,#11111111B
MEKS2:	JMP      TEK2
EFS4:   JMP      EF4

;    3 
WE3:	JNB     AL3,WE31
	JMP     WE4
                                             
EF3:    CJNE    A,#00000011B,EFS4

WE31:	INC      R4
	CJNE     R4,#64,KER11
	MOV	 R4,#0
	MOV	 RAZ8,#11111111B
	SETB     AL3	

KER11:	CJNE     R4,#1,KER1
	CLR      C
	MOV      R1,#RAZ1
	JMP      TEK2
KER1:	CJNE     R4,#2,KER102
	CLR      C
	JMP      TEK2
KER102:	CJNE     R4,#3,KER101
	CLR      C
	JMP      TEK2

KER101:	CJNE     R4,#9,KER201
	CLR      C
	MOV	 RAZ1,#00111111B
	MOV      R1,#RAZ2
	JMP      TEK2
KER201:	CJNE     R4,#10,KER202
	CLR      C
	MOV	 RAZ1,#01111111B
	JMP      TEK2
KER202:	CJNE     R4,#11,KER2
	CLR      C
	MOV	 RAZ1,#11111111B
	JMP      TEK2

KER2:	CJNE     R4,#18,KER301
	CLR      C
	MOV	 RAZ2,#00111111B
	MOV      R1,#RAZ3
	JMP      TEK2
KER301:	CJNE     R4,#19,KER302
	CLR      C
	MOV	 RAZ2,#01111111B
	JMP      TEK2
KER302:	CJNE     R4,#20,KER3
	CLR      C
	MOV	 RAZ2,#11111111B
	JMP      TEK2

KER3:	CJNE     R4,#27,KER401
	CLR      C
	MOV	 RAZ3,#00111111B
	MOV      R1,#RAZ4
	JMP      TEK2
KER401:	CJNE     R4,#28,KER402
	CLR      C
	MOV	 RAZ3,#01111111B
	JMP      TEK2
KER402:	CJNE     R4,#29,KER4
	CLR      C
	MOV	 RAZ3,#11111111B
	JMP      TEK2

KER4:	CJNE     R4,#36,KER501
	CLR      C
	MOV	 RAZ4,#00111111B
	MOV      R1,#RAZ5
	JMP      TEK2
KER501:	CJNE     R4,#37,KER502
	CLR      C
	MOV	 RAZ4,#01111111B
	JMP      TEK2
KER502:	CJNE     R4,#38,KER5
	CLR      C
	MOV	 RAZ4,#11111111B
	JMP      TEK2

KER5:	CJNE     R4,#45,KER601
	CLR      C
	MOV	 RAZ5,#00111111B
	MOV      R1,#RAZ6
	JMP      TEK2
KER601:	CJNE     R4,#46,KER602
	CLR      C
	MOV	 RAZ5,#01111111B
	JMP      TEK2
KER602:	CJNE     R4,#47,KER6
	CLR      C
	MOV	 RAZ5,#11111111B
	JMP      TEK2

KER6:	CJNE     R4,#54,KER701
	CLR      C
	MOV	 RAZ6,#00111111B
	MOV      R1,#RAZ7
	JMP      TEK2
KER701:	CJNE     R4,#55,KER702
	CLR      C
	MOV	 RAZ6,#01111111B
	JMP      TEK2
KER702:	CJNE     R4,#56,KER7
	CLR      C
	MOV	 RAZ6,#11111111B
	JMP      TEK2

KER7:	CJNE     R4,#63,KER801
	CLR      C
	MOV	 RAZ7,#00111111B
	MOV      R1,#RAZ8
KER801:	CJNE     R4,#64,KER802
	CLR      C
	MOV	 RAZ7,#01111111B
	JMP      TEK2
KER802:	CJNE     R4,#65,TEK2
	CLR      C
	MOV	 RAZ7,#11111111B
	
TEK2:	MOV	 A,@R1
	RLC	 A
	MOV	 @R1,A
	JMP	 SE1
EFS5:	JMP	 EF5

WE4:	JNB     AL4,WE41
	JMP     WE5

;    4   

EF4:    CJNE     A,#00000100B,EFS5

WE41:	INC      R4
	CJNE     R4,#16,NELOZ1
	MOV	 R4,#0
	MOV	 RAZ8,#11111111B
	SETB     AL4
	JMP      SE1

NELOZ1:	CJNE     R4,#1,NEL1
	MOV	 RAZ1,#11110000B
	JMP	 SE1
NEL1:	CJNE     R4,#2,NEL2
	MOV	 RAZ1,#00001111B
	JMP	 SE1
NEL2:	CJNE     R4,#3,NEL3
	MOV	 RAZ1,#11111111B
	MOV	 RAZ2,#11110000B
	JMP	 SE1
NEL3:	CJNE     R4,#4,NEL4
	MOV	 RAZ2,#00001111B
	JMP	 SE1
NEL4:	CJNE     R4,#5,NEL5
	MOV	 RAZ2,#11111111B
	MOV	 RAZ3,#11110000B
	JMP	 SE1
NEL5:	CJNE     R4,#6,NEL6
	MOV	 RAZ3,#00001111B
	JMP	 SE1
NEL6:	CJNE     R4,#7,NEL7
	MOV	 RAZ3,#11111111B
	MOV	 RAZ4,#11110000B
	JMP	 SE1
NEL7:	CJNE     R4,#8,NEL8
	MOV	 RAZ4,#11111111B
	MOV	 RAZ5,#11110000B
	JMP	 SE1
NEL8:	CJNE     R4,#9,NEL9
	MOV	 RAZ5,#00001111B
	JMP	 SE1
NEL9:	CJNE     R4,#10,NEL10
	MOV	 RAZ5,#11111111B
	MOV	 RAZ6,#11110000B
	JMP	 SE1
NEL10:	CJNE     R4,#11,NEL11
	MOV	 RAZ6,#00001111B
	JMP	 SE1
NEL11:	CJNE     R4,#12,NEL12
	MOV	 RAZ6,#11111111B
	MOV	 RAZ7,#11110000B
	JMP	 SE1
NEL12:	CJNE     R4,#13,NEL13
	MOV	 RAZ7,#00001111B
	JMP	 SE1
NEL13:	CJNE     R4,#14,NEL14
	MOV	 RAZ7,#11111111B
	MOV	 RAZ8,#11110000B
	JMP	 SE1
NEL14:	CJNE     R4,#15,EF5
	MOV	 RAZ8,#00001111B	
	JMP	 SE1
EFS6:   JMP      EF6

;    5  

WE5:	JNB     AL5,WE51
	JMP     WE6
 
EF5:    CJNE     A,#00000101B,EFS6

WE51:	INC      R4
	CJNE     R4,#9,ZERF1
	JNB      REV,ZLO2  
	CPL      REV1

	INC      R2
	CJNE     R2,#4,ZLO2
	MOV      R2,#0
	SETB     AL5

ZLO2:	MOV	 R4,#0
	MOV	 RAZ8,#11111111B
	MOV	 RAZ1,#11111111B
	JMP      SE1

ZERF1:	JNB      REV,DELOZ1     ;     
        JNB      REV1,DELOZ2 

DELOZ1:	CJNE     R4,#1,FEL1
	MOV	 RAZ1,#00000000B
	JMP	 SE1
FEL1:	CJNE     R4,#2,FEL2
	MOV	 RAZ1,#11111111B
	MOV	 RAZ2,#00000000B
	JMP	 SE1
FEL2:	CJNE     R4,#3,FEL3
	MOV	 RAZ2,#11111111B
	MOV	 RAZ3,#00000000B
	JMP	 SE1
FEL3:	CJNE     R4,#4,FEL4
	MOV	 RAZ3,#11111111B
	MOV	 RAZ4,#00000000B
	JMP	 SE1
FEL4:	CJNE     R4,#5,FEL5
	MOV	 RAZ4,#11111111B
	MOV	 RAZ5,#00000000B
	JMP	 SE1
FEL5:	CJNE     R4,#6,FEL6
	MOV	 RAZ5,#11111111B
	MOV	 RAZ6,#00000000B
	JMP	 SE1
FEL6:	CJNE     R4,#7,FEL7
	MOV	 RAZ6,#11111111B
	MOV	 RAZ7,#00000000B
	JMP	 SE1
FEL7:	CJNE     R4,#8,EF6
	MOV	 RAZ7,#11111111B
	MOV	 RAZ8,#00000000B
	JMP	 SE1

	;

DELOZ2:	CJNE     R4,#1,FEV1
	MOV	 RAZ8,#00000000B
	JMP	 SE1
FEV1:	CJNE     R4,#2,FEV2
	MOV	 RAZ8,#11111111B
	MOV	 RAZ7,#00000000B
	JMP	 SE1
FEV2:	CJNE     R4,#3,FEV3
	MOV	 RAZ7,#11111111B
	MOV	 RAZ6,#00000000B
	JMP	 SE1
FEV3:	CJNE     R4,#4,FEV4
	MOV	 RAZ6,#11111111B
	MOV	 RAZ5,#00000000B
	JMP	 SE1
FEV4:	CJNE     R4,#5,FEV5
	MOV	 RAZ5,#11111111B
	MOV	 RAZ4,#00000000B
	JMP	 SE1
FEV5:	CJNE     R4,#6,FEV6
	MOV	 RAZ4,#11111111B
	MOV	 RAZ3,#00000000B
	JMP	 SE1
FEV6:	CJNE     R4,#7,FEV7
	MOV	 RAZ3,#11111111B
	MOV	 RAZ2,#00000000B
	JMP	 SE1
FEV7:	CJNE     R4,#8,EF6
	MOV	 RAZ2,#11111111B
	MOV	 RAZ1,#00000000B
	JMP	 SE1
	
;    6 

WE6:	JNB     AL6,WE61
	JMP     WE7
  
EF6:    CJNE     A,#00000110B,EF7

WE61:	INC      R4

	CJNE     R4,#3,MOK2
	MOV      R4,#0

	INC      R2
	CJNE     R2,#5,SEM1
	MOV      R2,#0
	SETB     AL6

SEM1:	JMP      SE1

MOK2:	CJNE     R4,#1,MOK1
	MOV	 RAZ1,#01010101B
	MOV	 RAZ2,#01010101B
	MOV	 RAZ3,#01010101B
	MOV	 RAZ4,#01010101B
	MOV	 RAZ5,#01010101B
	MOV	 RAZ6,#01010101B
	MOV	 RAZ7,#01010101B
	MOV	 RAZ8,#01010101B
	JMP	 SE1
MOK1:   CJNE     R4,#2,SEM1
	
	MOV	 RAZ1,#10101010B
	MOV	 RAZ2,#10101010B
	MOV	 RAZ3,#10101010B
	MOV	 RAZ4,#10101010B
	MOV	 RAZ5,#10101010B
	MOV	 RAZ6,#10101010B
	MOV	 RAZ7,#10101010B
	MOV	 RAZ8,#10101010B
	JMP	 SE1
EFS8:   JMP	 EF8

;        7( )
WE7:	JNB     AL7,WE71
	JMP     WE8
  
EF7:    CJNE     A,#00000111B,EFS8

WE71:	INC      R4
	CJNE     R4,#72,ZER11
	JNB      REV,ZLO1  
	CPL      REV1
	INC      R2
	CJNE     R2,#4,ZLO1
	MOV      R2,#0
	SETB     AL7

ZLO1:	MOV	 R4,#0
	MOV	 RAZ1,#11111111B
	MOV	 RAZ2,#11111111B
	MOV	 RAZ3,#11111111B
	MOV	 RAZ4,#11111111B
	MOV	 RAZ5,#11111111B
	MOV	 RAZ6,#11111111B
	MOV	 RAZ7,#11111111B
	MOV	 RAZ8,#11111111B
	JMP      SE1

ZER11:	JNB      REV,ZER0     ;     
        JNB      REV1,ZEZ0 

ZER0:	CJNE     R4,#1,ZER1
	MOV      R1,#RAZ1
	JMP      ZEK2
ZER1:	CJNE     R4,#9,ZER2
	MOV      R1,#RAZ2
	JMP      ZEK2
ZER2:	CJNE     R4,#18,ZER3
	MOV      R1,#RAZ3
	JMP      ZEK2
ZER3:	CJNE     R4,#27,ZER4
	MOV      R1,#RAZ4
	JMP      ZEK2
ZER4:	CJNE     R4,#36,ZER5
	MOV      R1,#RAZ5
	JMP      ZEK2
ZER5:	CJNE     R4,#45,ZER6
	MOV      R1,#RAZ6
	JMP      ZEK2
ZER6:	CJNE     R4,#54,ZER7
	MOV      R1,#RAZ7
	JMP      ZEK2
ZER7:	CJNE     R4,#63,ZEK2	
	MOV      R1,#RAZ8

ZEK2:	CLR      C
	MOV	 A,@R1
	RLC	 A
	MOV	 @R1,A
ZEKS2:  JMP	 SE1

	;

ZEZ0:	CJNE     R4,#1,ZEZ1
	MOV      R1,#RAZ8
	JMP      ZEX2
ZEZ1:	CJNE     R4,#9,ZEZ2
	MOV      R1,#RAZ7
	JMP      ZEX2
ZEZ2:	CJNE     R4,#18,ZEZ3
	MOV      R1,#RAZ6
	JMP      ZEX2
ZEZ3:	CJNE     R4,#27,ZEZ4
	MOV      R1,#RAZ5
	JMP      ZEX2
ZEZ4:	CJNE     R4,#36,ZEZ5
	MOV      R1,#RAZ4
	JMP      ZEX2
ZEZ5:	CJNE     R4,#45,ZEZ6
	MOV      R1,#RAZ3
	JMP      ZEX2
ZEZ6:	CJNE     R4,#54,ZEZ7
	MOV      R1,#RAZ2
	JMP      ZEX2
ZEZ7:	CJNE     R4,#63,ZEX2	
	MOV      R1,#RAZ1
ZEX2:	CLR      C
	MOV	 A,@R1
	RRC	 A
	MOV	 @R1,A
        JMP	 SE1

;        8(.  . ) 
WE8:	JNB     AL8,WE81
	JMP     WE9
 
EF8:    CJNE     A,#00001000B,EF9

WE81:	INC      R4

        CJNE     R4,#7,WER2
	MOV	 R4,#0

	INC      R2
	CJNE     R2,#4,SEW1
	MOV      R2,#0
	SETB     AL8

SEW1:	JMP      SE1

WER2:	CJNE     R4,#3,WER1
	MOV	 RAZ1,#11111111B
	MOV	 RAZ2,#11111111B
	MOV	 RAZ3,#11111111B
	MOV	 RAZ4,#11111111B
	MOV	 RAZ5,#11111111B
	MOV	 RAZ6,#11111111B
	MOV	 RAZ7,#11111111B
	MOV	 RAZ8,#11111111B
	JMP      SE1
WER1:   CJNE     R4,#6,SEW1
;	MOV	 R4,#0
	MOV	 RAZ1,#0
	MOV	 RAZ2,#0
	MOV	 RAZ3,#0
	MOV	 RAZ4,#0
	MOV	 RAZ5,#0
	MOV	 RAZ6,#0
	MOV	 RAZ7,#0
	MOV	 RAZ8,#0
	JMP      SE1

WE9:	MOV	 BAIT2,#00000000B 

EF9:    JMP	 SE1

OT:     CLR      TR0  		;     TR0                  
        MOV      TL0,#LOW(-3400)         
        MOV      TH0,#HIGH(-3400)     
        SETB     TR0
	PUSH	 PSW                     
        PUSH     ACC 

EMOV2:	DJNZ	 R3,EMOL1

	CJNE     R6,#1,DAL1
	MOV	 R3,#10
	SETB	 PUSK
	JMP      EMOL1
DAL1:	CJNE     R6,#2,DAL2
	MOV	 R3,#15
	SETB	 PUSK
	JMP      EMOL1
DAL2:	CJNE     R6,#3,DAL3
	MOV	 R3,#20
	SETB	 PUSK
	JMP      EMOL1
DAL3:   CJNE     R6,#4,DAL4
	MOV	 R3,#25
	SETB	 PUSK
	JMP      EMOL1
DAL4:   CJNE     R6,#5,DAL5
	MOV	 R3,#30
	SETB	 PUSK
	JMP      EMOL1
DAL5:   CJNE     R6,#6,DAL6
	MOV	 R3,#35
	SETB	 PUSK
	JMP      EMOL1
DAL6:   CJNE     R6,#7,DAL7
	MOV	 R3,#40
	SETB	 PUSK
	JMP      EMOL1
DAL7:   CJNE     R6,#8,DAL8
	MOV	 R3,#45
	SETB	 PUSK
	JMP      EMOL1
DAL8:   CJNE     R6,#9,EMOL1
	MOV	 R3,#50
	SETB	 PUSK

EMOL1:	DJNZ	ZADKN,SAS5 ;SA5
	MOV	ZADKN,#10

	MOV	 P1,#11111110B	;  1(/)
	NOP
        JB       P3.0,S1

        JB       FLAG,SAS5 
        SETB     FLAG
        CPL      PUSK1
SAS5:	JMP	 SA5
S1:     CLR      FLAG

       
SA1:   	MOV	 P1,#11111101B   ;  2(    .)
	NOP
        JB       P3.0,S2
        JB       FLAG1, SAS5 ;(SA5)
        SETB     FLAG1
	CPL	 COMB
	CPL	 REV
	MOV	 BAIT2,#00000000B 
	JMP	 SA5

S2:     CLR      FLAG1
        
SA2:    MOV	 P1,#11111011B	;  3 ( )
        JB       P3.0,S3 
        JB       FLAG2,KN1 ;(SA5)
        SETB     FLAG2
	CPL      WKLW

RE1:    JB       WKLW,SENO1    ;   
	MOV	 RAZ1,#11111111B
	MOV	 RAZ2,#11111111B
	MOV	 RAZ3,#11111111B
	MOV	 RAZ4,#11111111B
	MOV	 RAZ5,#11111111B
	MOV	 RAZ6,#11111111B
	MOV	 RAZ7,#11111111B
	MOV	 RAZ8,#11111111B
	JMP	 SA5
SENO1:  MOV	 RAZ1,#0
	MOV	 RAZ2,#0
	MOV	 RAZ3,#0
	MOV	 RAZ4,#0
	MOV	 RAZ5,#0
	MOV	 RAZ6,#0
	MOV	 RAZ7,#0
	MOV	 RAZ8,#0
KN1:    JMP	 SA5	
	
S3:     CLR      FLAG2
			
SA3:	MOV	 P1,#11110111B	;  4 ( )
	NOP
        JB       P3.0,S4 
        JB       FLAG3,KN1 ;SA5
        SETB     FLAG3
	CPL	 REV
	CPL      P3.7	
	
	JMP      SA5
S4:	CLR	 FLAG3 

SA4:	MOV	P1,#11101111B	;  5 (   )
	NOP
        JB      P3.0,S5 
        JB      FLAG4,SA5
	SETB	FLAG4
	CPL     P3.7
	INC     R6
	CJNE    R6,#10,DALS0

	MOV	 R6,#1
	MOV	 R3,#10
	JMP      SA5

DALS0:	CJNE     R6,#1,DALS1
	MOV	 R3,#10	
	JMP      SA5
DALS1:	CJNE     R6,#2,DALS2
	MOV	 R3,#15
	JMP      SA5
DALS2:	CJNE     R6,#3,DALS3
	MOV	 R3,#20
	JMP      SA5
DALS3:  CJNE     R6,#4,DALS6
	MOV	 R3,#25
	JMP      SA5
DALS4:  CJNE     R6,#5,DALS5
	MOV	 R3,#30
	JMP      SA5
DALS5:  CJNE     R6,#6,DALS6
	MOV	 R3,#35
	JMP      SA5
DALS6:  CJNE     R6,#7,DALS7
	MOV	 R3,#40
	JMP      SA5
DALS7:  CJNE     R6,#8,DALS8
	MOV	 R3,#45
	JMP      SA5
DALS8:  CJNE     R6,#9,SA5
	MOV	 R3,#50
	
KTEM:	JMP      SA5
S5:	CLR	 FLAG4 
	

SA5:   	SETB	 ZN1PW		;  
	SETB	 ZN2PW
	SETB	 ZN3PW
	SETB	 ZN4PW
	SETB	 ZN5PW 
        SETB	 ZN6PW
	SETB	 ZN7PW
	SETB	 ZN8PW 
                    
FN0:    CJNE     R7,#1,FN1
	CLR	 ZN1PW 
        JMP	 FN11
FN1:	CJNE     R7,#2,FN2
	CLR	 ZN2PW         
        JMP	 FN11       
FN2:	CJNE     R7,#3,FN3
	CLR	 ZN3PW         
        JMP	 FN11
FN3:	CJNE     R7,#4,FN4
	CLR	 ZN4PW	
FN4:	CJNE     R7,#5,FN5
	CLR	 ZN5PW
	JMP	 FN11
FN5:	CJNE     R7,#6,FN6
	CLR	 ZN6PW
	JMP	 FN11
FN6:	CJNE     R7,#7,FN7
	CLR	 ZN7PW
	JMP	 FN11
FN7:	CJNE     R7,#8,FN11
	CLR	 ZN8PW

FN11:	CLR	 P3.1		;      DD1
	MOV	 P1,BAIT1
	NOP
	SETB	 P3.1
	NOP
	MOV      P1,@R0
			                         
FROS17: INC      R0
       	INC	 R7
            
TEMO0:  CJNE     R0,#38H,OUT
        MOV      R0,#RAZ1
	MOV	 R7,#1
	JNB      COMB,OUT  	   
        CPL      P3.7         
OUT:    POP      ACC 
        POP      PSW                                                                      
        RETI
	END
 











